#[macro_export]
macro_rules! get_handle_from_ptr {
    ($hptr:ident as $hval:ident) => {
        if $hptr.is_null() {
            return ZRFUErrNo::Generic_NullPointerHandle.get_return_code()
        };
        let $hval = unsafe { $hptr.read() };
    }
}

#[macro_export]
macro_rules! define_err_enum {
    ($( $behv:ident for $prefix:ident as $name:ident ), * ) => {
        #[allow(non_camel_case_types)]
        #[derive(Debug, TryFromPrimitive, IntoPrimitive, Display)]
        #[repr(u32)]
        pub enum ZRFUErrNo {
            OK = 0x00000000,
            Unknown = 0x4000FFFF,
            $(
                $name = ZRFUErrPrefix::$prefix.define(ZRFUErrBehavior::$behv),
            )*
        }

    }
}
